## eztrace 0.7

=== test/memory/Makefile ===
# Copyright  CNRS, INRIA, Universit Bordeaux 1
# See COPYING in top-level directory.

BINARIES = memory

all: $(BINARIES)

memory: memory.o
	$(CC) -o memory memory.c $(CFLAGS) $(LDFLAGS) $(LIBS) -lpthread

clean:
	rm -f  *.o $(BINARIES)

=== test/mpi/Makefile ===
# Copyright  CNRS, INRIA, Universit Bordeaux 1
# See COPYING in top-level directory.

BINARIES = mpi_ping test_mpi test_mpi_f mpi_ring persistent mpi_spawn mpi_openmp mpi_multiring waitany allgather waitall
# BINARIES += mpi_ping_vt
MPICC ?= mpicc
MPIF77 ?= mpif77
CC=$(MPICC)

all: $(BINARIES)

test_mpi_f: test_mpi_f.f
	$(MPIF77) -o test_mpi_f test_mpi_f.f

mpi_ping_vt: mpi_ping.c
	mpicc-vt -o mpi_ping_vt mpi_ping.c
#	vtcc -vt:cc $(MPICC) -o mpi_ping_vt mpi_ping.c

mpi_openmp: mpi_openmp.c
	$(MPICC) -o mpi_openmp mpi_openmp.c -fopenmp

clean:
	rm -f  *.o $(BINARIES)

=== test/openmp/Makefile ===
# Copyright  CNRS, INRIA, Universit Bordeaux 1
# See COPYING in top-level directory.

APPS:= simple openmp_nowait_c openmp_nowait

CC?=gcc
FC?=gfortran

all: $(APPS)

simple: simple.c
	$(CC) -o simple simple.c -fopenmp -lm $(CFLAGS) $(LDFLAGS)

openmp_nowait_c: openmp_nowait_c.c
	$(CC) -o openmp_nowait_c openmp_nowait_c.c -fopenmp -lm $(CFLAGS) $(LDFLAGS)

openmp_nowait: openmp_nowait.f
	$(FC) -o openmp_nowait openmp_nowait.f -fopenmp -lm $(CFLAGS) $(LDFLAGS)

clean:
	rm -f $(APPS)

=== test/pthread/Makefile ===
# Copyright  CNRS, INRIA, Universit Bordeaux 1
# See COPYING in top-level directory.

BINARIES = dummy_thread cond test_pthread test_sigsegv

all: $(BINARIES)

test_pthread: test_pthread.c
	$(CC) -o test_pthread test_pthread.c $(LDFLAGS) $(CFLAGS) -lpthread

test_sigsegv: test_sigsegv.c
	$(CC) -o test_sigsegv test_sigsegv.c -rdynamic

dummy_thread: dummy_thread.o
	$(CC) -o dummy_thread dummy_thread.o $(LDFLAGS) $(LIBS) -lpthread

dummy_thread.o: dummy_thread.c
	$(CC) -c dummy_thread.c $(CFLAGS)

cond: cond.o
	$(CC) -o cond cond.o $(LDFLAGS) $(LIBS) -lpthread

cond.o: cond.c
	$(CC) -c cond.c $(CFLAGS)

clean:
	rm -f  *.o $(BINARIES)

=== test/stdio/Makefile ===
# Copyright  CNRS, INRIA, Universit Bordeaux 1
# See COPYING in top-level directory.

BINARIES = stdio

all: $(BINARIES)

stdio: stdio.o
	$(CC) -o stdio stdio.c $(CFLAGS) $(LDFLAGS) $(LIBS) -lpthread

clean:
	rm -f  *.o $(BINARIES)

## eztrace 0.7-2

=== debian/changelog ===
eztrace (0.7-2-4) unstable; urgency=low

  * patches/plugins-abi-version: Fix abi version in configure.ac instead of
    source code, as it is needed in several places.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 30 Jun 2012 10:25:42 -0300

eztrace (0.7-2-3) unstable; urgency=low

  * patches/plugins-abi-version: Fix module loading without libeztrace-dev
    installed by making eztrace load with abi version, not just .so.
  * Only ship /usr/include/eztrace*

 -- Samuel Thibault <sthibault@debian.org>  Fri, 29 Jun 2012 13:16:49 -0300

eztrace (0.7-2-2) unstable; urgency=low

  * control: Move eztrace to section devel.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 24 May 2012 01:22:08 +0200

eztrace (0.7-2-1) unstable; urgency=low

  * Initial release (Closes: 658116)

 -- Samuel Thibault <sthibault@debian.org>  Sun, 20 May 2012 21:29:16 +0200

=== debian/control ===
Source: eztrace
Section: devel
Priority: extra
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper (>= 8.0.0), dh-autoreconf,
 hardening-wrapper, gfortran,
 libfxt-dev, libgtg-dev, libpomp-dev,
 mpi-default-dev
Standards-Version: 3.9.3
Homepage: http://eztrace.gforge.inria.fr/
Vcs-Git: git://git.debian.org/collab-maint/eztrace.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/eztrace.git;a=summary

Package: eztrace
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, opari
Description: Automatic execution trace generation for HPC - tools
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the tools.

Package: libeztrace-dev
Section: libdevel
Architecture: any
Depends: libeztrace0 (= ${binary:Version}), ${misc:Depends}
Description: Automatic execution trace generation for HPC - development files
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

Package: libeztrace0
Section: libs
Architecture: any
Multi-arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - development files
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_HARDENING=1

%:
	dh $@  --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-mpi-include=/usr/include/mpi --with-fxt=/usr --with-gtg=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

## eztrace 0.9.1

=== example/libexample_eztrace/Makefile ===
BIN = libeztrace-convert-example.so libeztrace-autostart-example.so libeztrace-example.so

# LDFLAGS=-LPATH_TO_EZTRACE/lib
# CFLAGS=-IPATH_TO_EZTRACE/include
all: $(BIN)

libeztrace-convert-example.so: eztrace_convert_example.c example_ev_codes.h
	$(CC) --shared -o libeztrace-convert-example.so eztrace_convert_example.c -fPIC $(CFLAGS) $(LDFLAGS) -ldl

libeztrace-example.so: example.c example_ev_codes.h
	$(CC) --shared -o libeztrace-example.so example.c -fPIC $(CFLAGS) $(LDFLAGS) -ldl

libeztrace-autostart-example.so: example.c example_ev_codes.h
	$(CC) --shared -o libeztrace-autostart-example.so example.c -fPIC $(CFLAGS) $(LDFLAGS) -ldl -DEZTRACE_AUTOSTART

clean:
	rm -f $(BIN)

=== example/libexample_orig/Makefile ===
BIN = libexample.so libstatic_example.a main main_mpi

all: $(BIN)

main_mpi: main.c example.h
	mpicc -o main_mpi main.c -L. -lexample

main: main.c example.h libexample.so libstatic_example.a
	$(CC) -o main main.c -L. -lexample libstatic_example.a -O0 -g

libexample.so: example.o
	$(CC) --shared -o libexample.so example.o -ldl

libstatic_example.a: static_example.o
	ar rcs libstatic_example.a static_example.o

static_example.o: static_example.c
	$(CC) -c static_example.c  -O0 -g

example.o: example.c example.h
	$(CC) -o example.o -c example.c -fPIC  -O0 -g


clean:
	rm -f $(BIN) *.o

=== test/module_generator/example_application/Makefile ===
BIN = libexample.so main

all: $(BIN)

main: main.c example.h
	$(CC) -o main main.c -L. -lexample

libexample.so: example.o
	$(CC) --shared -o libexample.so example.o -ldl

example.o: example.c example.h
	$(CC) -o example.o -c example.c -fPIC


clean:
	rm -f $(BIN) *.o

=== test/pptrace/automatic/testcase/Makefile ===
TESTCASES_=$(patsubst %.c,%,$(wildcard *.c))
ifeq "32" "$(shell getconf LONG_BIT)"
	BITS=32
else
	BITS=32 64
endif
TESTCASES=$(foreach testcase,$(TESTCASES_),$(foreach b,$(BITS),$(testcase).$(b) $(testcase).$(b).so))

all:	$(TESTCASES)

echo:
	echo '$(BITS) + $(TESTCASES_) = $(TESTCASES)'
	
%.32:	%.c
	@$(CC) -m32 -o $@ $^

%.64:	%.c
	@$(CC) -m64 -o $@ $^

%.32.so:	%.c
	@$(CC) -m32 -shared -fPIC -Wl,-Bsymbolic -o $@ $^

%.64.so:	%.c
	@$(CC) -m64 -shared -fPIC -Wl,-Bsymbolic -o $@ $^

clean:
	@rm -f $(TESTCASES)

=== debian/changelog ===
eztrace (0.9.1-5) unstable; urgency=low

  * control: Replace binutils-dev build-dependency with libiberty-dev for
    libiberty.a
    (Closes: #730945).

 -- Samuel Thibault <sthibault@debian.org>  Mon, 02 Dec 2013 16:31:23 +0100

eztrace (0.9.1-4) unstable; urgency=low

  * Bump Standards-Version to 3.9.5 (no changes).
  * patches/static-bfd: Link against libbfd statically to avoid rebuilding on
    each and every binutils upload (Closes: #728084).

 -- Samuel Thibault <sthibault@debian.org>  Fri, 01 Nov 2013 16:05:36 +0100

eztrace (0.9.1-3) unstable; urgency=medium

  * patches/manpages: Import manpages from upstream trunk.
  * control: Make eztrace depend on the same version of libeztrace0.
  * patches/libdir: Fix autostart load by fixing multiarch libdir.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 09 Oct 2013 19:01:27 +0200

eztrace (0.9.1-2) unstable; urgency=low

  * patches/pptrace-option: Add --without-pptrace option.
  * rules: Disable pptrace on non-linux-x86 ports.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 06 Sep 2013 00:23:00 +0200

eztrace (0.9.1-1) unstable; urgency=low

  * New upstream release.
    - patches/parameter_parsing_crash: Drop, merged upstream.
    - docs: Add README.stats.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 05 Sep 2013 17:33:34 +0200

eztrace (0.9-1) unstable; urgency=low

  * New upstream release.
    - patches/gtg: Remove, fixed upstream.
    - patches/extlib: Refresh.
    - control: switch to opari2.
  * Bump Standards-Version to 3.9.4 (no changes).
  * rules: Disable PIE hardening, it makes the static test module hang.
  * patches/test-fix: Fix test segfault.
  * patches/plugins-abi-version: Fix static test module too.
  * patches/mpi-fix: Fix list issue in MPI conversion.
  * patches/mpi3: Fix bindnow support when MPI3 is not supported.
  * control: add mpirun.
  * patches/no-libpomp: Do not build a libpomp, use the one from libpomp2-dev.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 05 Sep 2013 16:30:05 +0200

eztrace (0.7-2-5) unstable; urgency=low

  * control: Make libeztrace-dev Multi-Arch: same.
  * patches/parameter_parsing_crash: Fix a parameter parsing crash.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 27 Jun 2013 14:21:44 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,10 @@
 Maintainer: Samuel Thibault <sthibault@debian.org>
 Build-Depends: debhelper (>= 8.0.0), dh-autoreconf,
  hardening-wrapper, gfortran,
- libfxt-dev, libgtg-dev, libpomp-dev,
- mpi-default-dev
-Standards-Version: 3.9.3
+ libiberty-dev, libfxt-dev, fxt-tools, libgtg-dev, libpomp2-dev,
+ mpi-default-dev, mpi-default-bin
+Build-Conflicts: libeztrace0
+Standards-Version: 3.9.5
 Homepage: http://eztrace.gforge.inria.fr/
 Vcs-Git: git://git.debian.org/collab-maint/eztrace.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/eztrace.git;a=summary
@@ -14,7 +15,7 @@
 Package: eztrace
 Section: devel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, opari
+Depends: ${shlibs:Depends}, ${misc:Depends}, libeztrace0 (= ${binary:Version}), opari2
 Description: Automatic execution trace generation for HPC - tools
  EZTrace is a tool that aims at generating automatically execution traces
  from HPC (High Performance Computing) programs. It generates execution
@@ -27,6 +28,7 @@
 Package: libeztrace-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libeztrace0 (= ${binary:Version}), ${misc:Depends}
 Description: Automatic execution trace generation for HPC - development files
  EZTrace is a tool that aims at generating automatically execution traces

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_OS=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_BUILD_HARDENING=1
export DEB_BUILD_HARDENING_PIE=0

NO_PPTRACE=

ifneq ($(DEB_HOST_ARCH_OS),linux)
NO_PPTRACE=--without-pptrace
endif
ifneq ($(DEB_HOST_ARCH_CPU),i386)
ifneq ($(DEB_HOST_ARCH_CPU),amd64)
NO_PPTRACE=--without-pptrace
endif
endif

%:
	dh $@  --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(NO_PPTRACE) --with-mpi-include=/usr/include/mpi --with-fxt=/usr --with-gtg=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	-dh_auto_test

=== debian/watch ===
version=3
https://gforge.inria.fr/frs/?group_id=2774 /frs/download.php/.*/eztrace-(.*)\.tar\.gz

## eztrace 1.0.6

=== debian/changelog ===
eztrace (1.0.6-5) unstable; urgency=medium

  * patches/git-1f988a88ea495623164c073d5bd99220b4b3fcde: Cherry-pick from
    upstream to fix gcc-5 build (Closes: Bug#777847).
  * watch: Generalize URL.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 16 Jun 2015 23:46:06 +0200

eztrace (1.0.6-4) unstable; urgency=medium

  * patches/libdir: Fix plugin path search for the pptrace case
    (closes: Bug#775286).
  * rules: Do not strip modules for pptrace auto-load, otherwise they won't be
    loadable.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 14 Jan 2015 14:52:50 +0100

eztrace (1.0.6-3) unstable; urgency=medium

  * patches/git-ebe444a: Cherry-pick from upstream to fix uninitialized value.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 02 Dec 2014 22:56:57 +0100

eztrace (1.0.6-2) unstable; urgency=medium

  [ Peter Michael Green ]
  * Remove -march=armv7-a from CFLAGS (Closes: Bug#770793).

  [ Samuel Thibault ]
  * Only enable pptrace support (which needs armv7) on armhf.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 24 Nov 2014 14:38:20 +0100

eztrace (1.0.6-1) unstable; urgency=medium

  * New upstream release.
  * patches/git-0cb79edc3411c0e04e411d7c8f60a6596632a4ea: Fix bogus
    parameters (Closes: Bug#760502).
  * patches/git-8be2d52dfe036666a75160aa33531a52d5f2257a: Fix licence
    advertised in documentation.
  * patches/pptrace, non_linux: Remove, merged upstream.
  * patches/check: Remove, fixed upstream.
  * Bump Standards-Version to 3.9.6 (no changes).

 -- Samuel Thibault <sthibault@debian.org>  Thu, 23 Oct 2014 15:56:45 +0200

eztrace (1.0.5-3) unstable; urgency=medium

  * Disable EZTRACE_SIGALRM on !linux.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 11 Sep 2014 15:43:43 +0200

eztrace (1.0.5-2) unstable; urgency=medium

  * Fix disabling pptrace on !linux !amd64 !arm.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 10 Sep 2014 18:05:24 +0200

eztrace (1.0.5-1) unstable; urgency=medium

  * New upstream release.
    - patches/fix_fortran_mpi_scatterv.patch: Remove, fixed upstream.
    - patches/Fix-fortan-communications-using-MPI_IN_PLACE-option.patch:
    Remove, fixed upstream.
    - patches/rpath: Remove, fixed upstream.
    - patches/static-bfd: Refresh.
  * rules: Fix calling testsuite.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 10 Sep 2014 17:23:49 +0200

eztrace (1.0.1-2) unstable; urgency=medium

  * patches/fix_fortran_mpi_scatterv.patch: Patch from Bertrand Putigny to fix
    the MPIF_Scatterv call.
  * patches/Fix-fortan-communications-using-MPI_IN_PLACE-option.patch: Patch
    from Bertrand Putigny to fix fortran mpi communications using MPI_IN_PLACE.
  * rules: Add parallel build support.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 10 Sep 2014 14:01:53 +0200

eztrace (1.0.1-1) unstable; urgency=medium

  * New upstream bugfix release.
  * control: Do not depend on openmpi on s390x (Closes: Bug#754624).
  * rules: Do not build against openmpi on s390x. Drop duplicate
  --with-mpi-include option. Run the testsuite against openmpi on other archs.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 13 Jul 2014 16:29:46 +0200

eztrace (1.0-1) unstable; urgency=medium

  * New upstream release.
  * Add missing zlib1g-dev build-dependency.
  * debian/copyright: Update, eztrace is now CeCILL-B instead of GPL2.
  * debian/rules: Build both mpich and openmpi MPI modules.
  * debian/control: Build-Depend on both mpich and openmpi.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 26 Jun 2014 09:47:38 +0200

eztrace (1.0~rc4-3-1) experimental; urgency=medium

  * New upstream half-release.
  * Disable pptrace on i386 too, as it is missing the MMAP_SYSCALLS
    definition. Enable it on arm, which now support it.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 25 Jun 2014 13:45:12 +0200

eztrace (1.0~rc4-2-1) experimental; urgency=medium

  * New upstream half-release.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 25 Jun 2014 11:08:49 +0200

eztrace (1.0~rc4-1) experimental; urgency=medium

  * New upstream release.
    - patches/bibliography: Remove patch, fixed upstream
  * control: Add missing binutils-dev and litl-tools build-deps.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 24 Jun 2014 18:04:42 +0200

eztrace (1.0~rc3-1) experimental; urgency=medium

  * New upstream release.
    - patches/{libdir,link}: Remove patch, fixed upstream.
    - patches/bibliography: Fix building the documentation.
  * Do not install static libraries.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 11 Jun 2014 09:13:23 +0200

eztrace (1.0~rc1-2) experimental; urgency=medium

  * Depend on libpapi-dev only on Linux archs, and not on s390x.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 May 2014 18:46:40 +0200

eztrace (1.0~rc1-1) experimental; urgency=low

  * New upstream release.
    - patches/manpages, test-fix, mpi-fix, mpi3, pptrace-option,
    clang-ftbfs: Drop, integrated upstream.
    - control: Replace libfxt-dev build-depend with liblitl-dev.
    - rules: Replace fxt with litl.
  * patches/link: New patch, fix missing link againt liblitl.
  * patches/rpath: New patch, drop /usr/lib rpath.
  * control: Build-depend on libpapi-dev.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 19 May 2014 23:43:05 +0200

eztrace (0.9.1-6) unstable; urgency=low

  [ Arthur Marble ]
  * Fix FTBFS with clang (Closes: #743007).
    - Fixed the conflicting types error in
      src/core/eztrace_convert_core.c: moved a function above before where it is
      called.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 02 Apr 2014 17:14:00 +0200

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH_CPU=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_OS=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_BUILD_HARDENING=1
export DEB_BUILD_HARDENING_PIE=0

ifeq ($(DEB_HOST_ARCH_CPU),s390x)
OPENMPI=no
else
OPENMPI=yes
endif

CONFIGURE=--with-litl=/usr --with-gtg=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -Bbuild-mpich -- $(CONFIGURE) --with-mpi-include=/usr/include/mpich --with-mpi-module-name=mpich --with-mpi-event-id=4
ifeq ($(OPENMPI),yes)
	dh_auto_configure -Bbuild-openmpi -- $(CONFIGURE) --with-mpi-include=/usr/lib/openmpi/include --with-mpi-module-name=openmpi --with-mpi-event-id=10
endif

override_dh_auto_build:
	dh_auto_build -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_build -Bbuild-openmpi -- -C src/modules/mpi
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_clean -Bbuild-openmpi
endif
	rm -f test/automake/testcommon.h

override_dh_auto_install:
	dh_auto_install -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_install -Bbuild-openmpi -- -C src/modules/mpi
endif

override_dh_auto_test:
	-dh_auto_test -Bbuild-mpich -- -k
ifeq ($(OPENMPI),yes)
	-dh_auto_test -Bbuild-openmpi -- -C src/modules/mpi -k
endif

# TODO: remove with newer upstream release
override_dh_strip:
	dh_strip -Xlibeztrace-autostart-

=== debian/watch ===
version=3
https://gforge.inria.fr/frs/?group_id=2774 /frs/download.php/.*/eztrace-(\d.*)\.(?:zip|tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## eztrace 1.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)

# include CMake modules
INCLUDE (CheckLibraryExists)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckFunctionExists)

project (EZTrace C Fortran)
#set (INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
list(APPEND CMAKE_INSTALL_RPATH  "${CMAKE_CURRENT_BINARY_DIR}/extlib/lib")
# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# the RPATH to be used when installing
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

# CMakeFind repository
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)

# Check libraries and functions
find_library(BFD_LIBRARY bfd)
find_library(IBERTY_LIBRARY iberty)

CHECK_LIBRARY_EXISTS(bfd bfd_demangle "" bfd_demangle_exist)
if (NOT bfd_demangle_exist)
  message(FATAL_ERROR "libbfd: bfd_demangle not found")
endif()

option(EZTRACE_ENABLE_IBERTY      "Enable libiberty"    OFF)
CHECK_LIBRARY_EXISTS(iberty cplus_demangle "" cplus_demangle_exist)
if (NOT cplus_demangle_exist)
  message(FATAL_ERROR "libiberty: cplus_demangle not found")
else ()
  message(WARNING " libiberty detected, you can try to use it with -DHAVE_DEMANGLE")
endif()

#TRY_COMPILE(COMPILE_IBERTY ${CMAKE_CURRENT_BINARY_DIR}  ${CMAKE_SOURCE_DIR}/cmake_modules/tetIberty.c COMPILE_DEFINITIONS "${CMAKE_C_FLAGS} " OUTPUT_VARIABLE COMPILE_IBERTY_OUTPUT)

CHECK_LIBRARY_EXISTS(dl dlsym "" dlsym_exist)
if (NOT dlsym_exist)
  message(FATAL_ERROR "libdl: dlsym not found")
endif()

CHECK_LIBRARY_EXISTS(m cos "" cos_exist)
if (NOT cos_exist)
  message(WARNING "libm: cos not found")
endif()

CHECK_LIBRARY_EXISTS(pthread pthread_create "" pthread_create_exist)
CHECK_LIBRARY_EXISTS(pthread pthread_spin_lock "" full_pthread)
if (NOT pthread_create_exist)
  message(FATAL_ERROR "libpthread: pthread_create not found")
endif()

CHECK_LIBRARY_EXISTS(z deflate "" z_exist)
if (NOT z_exist)
  message(FATAL_ERROR "libz: deflate not found")
endif()

CHECK_LIBRARY_EXISTS(m cos "" cos_exist)
if (NOT cos_exist)
  message(WARNING "libm: cos not found")
endif()

set (HAVE_LIBOPCODE "1")
find_package (LibOpcodes)
CHECK_LIBRARY_EXISTS(opcodes disassembler "" disassembler_exist)
if (NOT disassembler_exist)
  set (HAVE_LIBOPCODE "0")
  message(WARNING "libopcodes: disassembler not found")
  message(WARNING "EZtrace will work better with LibOpcodes")
endif()

set (LIBRARY_PATH "${CMAKE_INSTALL_PREFIX}/lib")

# Internals stuff
if ("${APPLE}")
  set (CFLAGS "$CFLAGS -DHAVE_DARWIN")
  set (DYNLIB_EXT ".dylib")
  set (LD_PRELOAD_NAME "DYLD_INSERT_LIBRARIES")
  set (LD_LIBRARY_PATH_NAME "DYLD_LIBRARY_PATH")
else() # By default -> Linux
  set (CLFAGS "-DHAVE_LINUX -Wno-unused-parameter -Wno-unused-value")
  set (DYNLIB_EXT ".so")
  set (LD_PRELOAD_NAME "LD_PRELOAD")
  set (LD_LIBRARY_PATH_NAME "LD_LIBRARY_PATH")
endif()

set (PPTRACE_BINARY_TYPE "1")
set (__PPTRACE_BINARY_TYPE "1")
set (BINARY_LIB ${LIBBFD_LIBRARIES})
CHECK_INCLUDE_FILES ("sys/prctl.h" HAVE_PRCTL_H)
set (abs_top_builddir ${CMAKE_BINARY_DIR})

# Look for library

#find_package (OpenMP)

# Options to enable/disable modules
option(EZTRACE_ENABLE_MPI      "Enable MPI module"     ON)
option(EZTRACE_ENABLE_CUDA     "Enable CUDA module"    OFF)
option(EZTRACE_ENABLE_STARPU   "Enable StarPU module"  OFF)
option(EZTRACE_ENABLE_OPENMP   "Enable OpenMP module"  OFF)
option(EZTRACE_ENABLE_PAPI     "Enable PAPI module"    OFF)

if (EZTRACE_ENABLE_MPI)
  find_package (MPI REQUIRED)
endif()

if (EZTRACE_ENABLE_STARPU)
  find_package (STARPU REQUIRED COMPONENTS HWLOC MPI)
  if (NOT STARPU_FOUND)
    message(ERROR "StarPU not FOUND")
  endif()
  list (APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
endif()

if (EZTRACE_ENABLE_PAPI)
  find_package (LibPapi REQUIRED)
endif()

if (EZTRACE_ENABLE_CUDA)
  find_package (CUDA REQUIRED)
endif()

if (EZTRACE_ENABLE_OPENMP)
  find_package (OpenMP REQUIRED)
endif()

# Some flags for compilation
set (USE_LITL "1")
set (prefix "${CMAKE_INSTALL_PREFIX}")

# Files to convert
configure_file (${PROJECT_SOURCE_DIR}/src/core/eztrace_config.h.in ${PROJECT_SOURCE_DIR}/src/core/eztrace_config.h)
configure_file (${PROJECT_SOURCE_DIR}/src/core/eztrace.c.in ${PROJECT_SOURCE_DIR}/src/core/eztrace.c)
configure_file (${PROJECT_SOURCE_DIR}/test/automake/testcommon.h.in ${PROJECT_SOURCE_DIR}/test/automake/testcommon.h)

# Subdirectory
add_subdirectory (extlib)
add_subdirectory (src)

# Test section
#add_subdirectory (test)
#enable_testing ()

include(PrintOpts)

=== extlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
include(ExternalProject)

ExternalProject_Add(
   libGTG
   DOWNLOAD_COMMAND ""
   PREFIX ${CMAKE_CURRENT_SOURCE_DIR}/gtg
   SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/gtg
   CONFIGURE_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/gtg && autoreconf -vfi && ${CMAKE_CURRENT_SOURCE_DIR}/gtg/configure --prefix=${CMAKE_CURRENT_BINARY_DIR}
   BUILD_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/gtg && make
   INSTALL_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/gtg && make install
   )

 ExternalProject_Add(
    libOpari2
    DOWNLOAD_COMMAND ""
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/opari2
    PREFIX ${CMAKE_CURRENT_SOURCE_DIR}/opari2
    CONFIGURE_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/opari2/build-frontend && autoreconf -vfi && cd .. && autoreconf -vfi && ${CMAKE_CURRENT_SOURCE_DIR}/opari2/configure --prefix=${CMAKE_CURRENT_BINARY_DIR}
    BUILD_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/opari2/ && make
    INSTALL_COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR}/opari2 && make install
  )

add_subdirectory (litl)


install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/
  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
  )

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin/
  DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/)

=== extlib/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 3.2

# Default target executed when no arguments are given to make.
default_target: all
.PHONY : default_target

# Allow only one "make -f Makefile2" at a time, but pass parallelism.
.NOTPARALLEL:

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:

# Remove some rules from gmake that .SUFFIXES does not remove.
SUFFIXES =

.SUFFIXES: .hpux_make_needs_suffix_list

# Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:
.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/bin/cmake

# The command to remove a file.
RM = /usr/bin/cmake -E remove -f

# Escaping for special characters.
EQUALS = =

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /home/trahay/Soft/opt/eztrace/master

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /home/trahay/Soft/opt/eztrace/master

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/usr/bin/cmake -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: install/strip
.PHONY : install/strip/fast

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake cache editor..."
	/usr/bin/ccmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache
.PHONY : edit_cache/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/usr/bin/cmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache
.PHONY : rebuild_cache/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/usr/bin/cmake -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components
.PHONY : list_install_components/fast

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/usr/bin/cmake -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: install/local
.PHONY : install/local/fast

# The main all target
all: cmake_check_build_system
	cd /home/trahay/Soft/opt/eztrace/master && $(CMAKE_COMMAND) -E cmake_progress_start /home/trahay/Soft/opt/eztrace/master/CMakeFiles /home/trahay/Soft/opt/eztrace/master/extlib/CMakeFiles/progress.marks
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/all
	$(CMAKE_COMMAND) -E cmake_progress_start /home/trahay/Soft/opt/eztrace/master/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/clean
.PHONY : clean

# The main clean target
clean/fast: clean
.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	cd /home/trahay/Soft/opt/eztrace/master && $(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

# Convenience name for target.
extlib/CMakeFiles/libGTG.dir/rule:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/CMakeFiles/libGTG.dir/rule
.PHONY : extlib/CMakeFiles/libGTG.dir/rule

# Convenience name for target.
libGTG: extlib/CMakeFiles/libGTG.dir/rule
.PHONY : libGTG

# fast build rule for target.
libGTG/fast:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f extlib/CMakeFiles/libGTG.dir/build.make extlib/CMakeFiles/libGTG.dir/build
.PHONY : libGTG/fast

# Convenience name for target.
extlib/CMakeFiles/libOpari2.dir/rule:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f CMakeFiles/Makefile2 extlib/CMakeFiles/libOpari2.dir/rule
.PHONY : extlib/CMakeFiles/libOpari2.dir/rule

# Convenience name for target.
libOpari2: extlib/CMakeFiles/libOpari2.dir/rule
.PHONY : libOpari2

# fast build rule for target.
libOpari2/fast:
	cd /home/trahay/Soft/opt/eztrace/master && $(MAKE) -f extlib/CMakeFiles/libOpari2.dir/build.make extlib/CMakeFiles/libOpari2.dir/build
.PHONY : libOpari2/fast

# Help Target
help:
	@echo "The following are some of the valid targets for this Makefile:"
	@echo "... all (the default if no target is provided)"
	@echo "... clean"
	@echo "... depend"
	@echo "... install/strip"
	@echo "... edit_cache"
	@echo "... rebuild_cache"
	@echo "... install"
	@echo "... list_install_components"
	@echo "... libOpari2"
	@echo "... libGTG"
	@echo "... install/local"
.PHONY : help



#=============================================================================
# Special targets to cleanup operation of make.

# Special rule to run CMake to check the build system integrity.
# No rule that depends on this can have commands that come from listfiles
# because they might be regenerated.
cmake_check_build_system:
	cd /home/trahay/Soft/opt/eztrace/master && $(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 0
.PHONY : cmake_check_build_system

=== src/CMakeLists.txt ===
# Default installation path
set (INSTALL_DIR ${CMAKE_BINARY_DIR})
set (LIBRARY_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/lib)
set (EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

# Include directories
include_directories(
  ./core
  ./pptrace
  ./pptrace/arch
  ./pptrace/os/linux
  /usr/include/libiberty/
  ../extlib/litl/src/
  ${CMAKE_BINARY_DIR}/extlib/include
  )

link_directories(${CMAKE_BINARY_DIR}/lib ${CMAKE_BINARY_DIR}/extlib/lib)

set(CMAKE_C_FLAGS "-W -Wall ${CFLAGS} -DEZTRACE_LIB_DIR=\\\"${LIBRARY_PATH}/\\\" -DDYNLIB_EXT=\\\"${DYNLIB_EXT}\\\" -DEZTRACE_ABS_TOP_BUILDDIR=\\\"${abs_top_builddir}\\\"")

if (EZTRACE_ENABLE_IBERTY)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_DEMANGLE")
endif()

# Compile eztrace
add_executable(
  eztrace-bin
  ./core/eztrace.c
  ./core/ezt_demangle.c
  ./pptrace/pptrace.c
  ./pptrace/binary.c
  ./pptrace/errors.c
  ./pptrace/hijack.c
  ./pptrace/isize.c
  ./pptrace/memory.c
  ./pptrace/opcodes.c
  ./pptrace/tracing.c
)

target_link_libraries(
 eztrace-bin
 pthread
 opcodes
 litl
 bfd
 )

# Dependencies for building order
add_dependencies(eztrace-bin ${BINARY_LIB} litl)

# Change name : eztrace-bin -> eztrace
set_target_properties(eztrace-bin PROPERTIES OUTPUT_NAME eztrace)

# Compile libeztrace_convert_core
add_library(
  eztrace-convert-core
  SHARED
  core/eztrace_convert_core.c
  core/eztrace_stats_core.c
  core/eztrace_hierarchical_array.c
  core/eztrace_array.c
  core/submodules/ezt_submodule_convert.c
  core/submodules/ezt_getcpu_convert.c
  core/submodules/ezt_getcpu.h
  core/ezt_demangle.c
)

target_link_libraries(
 eztrace-convert-core
 libgtg.so
 dl
 pthread
 litl
 iberty
 )

# Compile eztrace-avail
add_executable(
  eztrace_avail
  core/eztrace_avail.c
)

target_link_libraries(
  eztrace_avail
  eztrace-convert-core
  dl
  libgtg.so
)

# Compile eztrace-loaded
add_executable(
  eztrace_loaded
  core/eztrace_loaded.c
)

target_link_libraries(
  eztrace_loaded
  eztrace-convert-core
  dl
  libgtg.so
  )

# Compile eztrace-stats
add_executable(
  eztrace_stats
  core/eztrace_stats.c
)

target_link_libraries(
  eztrace_stats
  eztrace-convert-core
  dl
  libgtg.so
  )

# Compile eztrace-convert
add_executable(
  eztrace_convert
  core/eztrace_convert.c
)

target_link_libraries(
  eztrace_convert
  eztrace-convert-core
  dl
  libgtg.so
)

# Compile libeztrace
add_library(
  eztrace
  SHARED
  core/eztrace_core.c
  core/eztrace_sampling.c
  core/pthread_core.c
  core/submodules/ezt_submodule.c
  core/submodules/ezt_getcpu.c
)

target_link_libraries(
  eztrace
  pthread
  bfd
  litl
  dl
  rt
)

# Compile libeztrace_autostart
add_library(
  eztrace-autostart
  SHARED
  core/eztrace_core.c
  core/eztrace_sampling.c
  core/pthread_core.c
  core/submodules/ezt_submodule.c
  core/submodules/ezt_getcpu.c
)

set_target_properties (eztrace-autostart PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART")

target_link_libraries(
  eztrace-autostart
  pthread
  litl
  dl
  bfd
  rt
)
set_target_properties (eztrace eztrace-autostart eztrace-convert-core eztrace-bin eztrace_convert eztrace_stats eztrace_avail  PROPERTIES LINK_FLAGS "-Wl,--no-undefined")

install(TARGETS eztrace-bin EXPORT eztrace DESTINATION bin)
install(TARGETS eztrace eztrace-autostart eztrace-convert-core eztrace_avail eztrace_loaded eztrace_convert eztrace_stats
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib)

add_subdirectory (modules)

=== example/libexample_eztrace/Makefile ===
--- 
+++ 
@@ -1,3 +1,6 @@
+# Copyright (C) CNRS, INRIA, Université Bordeaux 1, Télécom SudParis
+# See COPYING in top-level directory.
+
 BIN = libeztrace-convert-example.so libeztrace-autostart-example.so libeztrace-example.so
 
 # LDFLAGS=-LPATH_TO_EZTRACE/lib

=== extlib/litl/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(litl)

include_directories(src)

set (INSTALL_DIR ${CMAKE_BINARY_DIR})
set (LIBRARY_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/lib)
set (EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

set(CMAKE_C_FLAGS "-DVERSION=\\\"0.1.2\\\"")

file(
  GLOB_RECURSE
  source_files
  src/*.c
)

add_library(
  litl
  SHARED
  ${source_files}
)

target_link_libraries(
 litl
  pthread
)

add_executable(
 litl_merge
 utils/litl_merge.c
)

target_link_libraries(
 litl_merge
 litl
)

add_executable(
  litl_print
  utils/litl_print.c
)

target_link_libraries(
  litl_print
  litl
)

add_executable(
  litl_split
  utils/litl_split.c
)

target_link_libraries(
  litl_split
  litl
)

install(FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/litl_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/litl_read.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/litl_write.h
  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
  )

install(TARGETS litl_split litl_print litl_merge litl
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib)

=== src/modules/CMakeLists.txt ===
# Default modules
add_subdirectory(memory)
add_subdirectory(stdio)
add_subdirectory(pthread)

# Optional modules
if (EZTRACE_ENABLE_MPI)
  add_subdirectory(mpi)
endif ()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory(omp)
endif()

 if (EZTRACE_ENABLE_PAPI)
   add_subdirectory(papi)
 endif ()

 if (EZTRACE_ENABLE_STARPU)
   add_subdirectory(starpu)
 endif ()

 if (EZTRACE_ENABLE_CUDA)
   add_subdirectory(cuda)
endif ()

=== src/modules/memory/CMakeLists.txt ===
#include directories
include_directories(
  ../../core
  ../../pptrace
  ${CMAKE_BINARY_DIR}/include/
)

#libraries diretory
link_directories(${CMAKE_BINARY_DIR}/lib/ ${CMAKE_BINARY_DIR}/extlib/lib/)

#libeztrace-convert-memory.so
#Cflgas
set(CMAKE_C_FLAGS ${C_FLAGS})

add_library(
  eztrace-convert-memory
  SHARED
  eztrace_convert_memory.c
)

target_link_libraries(
 eztrace-convert-memory
 gtg
 litl
)

#libeztrace-memory.so
#CFlags

add_library(
  eztrace-memory
  SHARED
  memory.c
)

target_link_libraries(
 eztrace-memory
 eztrace
 litl
 dl
)

#libeztrace-autostart-memory.so
#CFlags
add_library(
  eztrace-autostart-memory
  SHARED
  memory.c
)


target_link_libraries(
 eztrace-autostart-memory
 eztrace
 litl
 dl
)

set_target_properties(eztrace-autostart-memory PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART")
install(TARGETS eztrace-convert-memory eztrace-memory eztrace-autostart-memory LIBRARY DESTINATION lib)

=== src/modules/mpi/CMakeLists.txt ===
# Include directories
include_directories(
  .
  ../../core
  ../../pptrace
  ${MPI_INCLUDE_PATH}
  ${MPI_Fortran_INCLUDE_PATH}
)

# Libraries diretory
link_directories(${CMAKE_BINARY_DIR}/lib/ ${CMAKE_BINARY_DIR}/extlib/lib/)

# Create : Libeztrace-convert-mpi.so
set(CMAKE_C_FLAGS "${C_FLAGS} -DUSE_MPI -DMPI_MODULE_NAME=mpi -DMPI_EVENT_ID=4")

add_definitions(${MPI_Fortran_COMPILE_FLAGS})

add_library(
  eztrace-convert-mpi
  SHARED
  eztrace_convert_mpi.c
  eztrace_convert_mpi_p2p.c
  eztrace_convert_mpi_coll.c
  eztrace_convert_mpi_pers.c
  eztrace_stats_mpi.c
)

target_link_libraries(
 eztrace-convert-mpi
 gtg
 ${INTERCEPT_LIB}
)

# Create : libeztrace-mpi.so
FILE(GLOB mpi_function_files mpi_funcs/*.c)

add_library(
  eztrace-mpi
  SHARED
  mpi.c
  mpi_fortran.c
  mpi_f.f90
  mpi3_f.f90
  ${mpi_function_files}
)


target_link_libraries(
  eztrace-mpi
  ${MPI_LIBRARIES}
  ${INTERCEPT_LIB}
 ${MPI_Fortran_LIBRARIES}
 eztrace
)

set_target_properties(eztrace-mpi PROPERTIES COMPILE_FLAGS "${MPI_COMPILE_FLAGS} -DLD_PRELOAD_NAME=\\\"${LD_PRELOAD_NAME}\\\" -DUSE_MPI3")

# Create : libeztrace-autostart-mpi.so
add_library(
  eztrace-autostart-mpi
  SHARED
  mpi.c
  mpi_fortran.c
  mpi_f.f90
  mpi3_f.f90
  ${mpi_function_files}
)


target_link_libraries(
  eztrace-autostart-mpi
  ${MPI_LIBRARIES}
  ${INTERCEPT_LIB}
  ${MPI_Fortran_LIBRARIES}
  eztrace
 )

set_target_properties(eztrace-autostart-mpi PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART ${MPI_COMPILE_FLAGS} -DLD_PRELOAD_NAME=\\\"${LD_PRELOAD_NAME}\\\" -DUSE_MPI3")
set_target_properties (eztrace-mpi eztrace-autostart-mpi PROPERTIES LINK_FLAGS "${MPI_LINK_FLAGS} -DUSE_MPI3")
install(TARGETS eztrace-convert-mpi eztrace-mpi eztrace-autostart-mpi LIBRARY DESTINATION lib)

=== src/modules/omp/CMakeLists.txt ===
# Include directories
include_directories(
  ../../core
  ../../pptrace
  ${CMAKE_BINARY_DIR}/include/
  ./pomp-lib-dummy/
  ../../../extlib/opari2/src/
  ../../../extlib/opari2/src/pomp-lib-dummy/
  ../../../extlib/opari2/build-frontend/
 .
)

# Libraries diretory
link_directories(${CMAKE_BINARY_DIR}/lib/ ${CMAKE_BINARY_DIR}/extlib/lib/)
set(C_FLAGS "${C_FLAGS} -DOPENMP_FOUND ${OpenMP_C_FLAGS}")

# create getfname executable to generate fortran mangling
#add_executable(
#  getfname
#  pomp-lib-dummy/foos.c
#  pomp-lib-dummy/getfname.f
#)

execute_process(COMMAND "gcc -o getfname foos.c getfname.f" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/pomp-lib-dummy")

# Compile libeztrace_convert_omp
add_library(
  eztrace-convert-omp
  SHARED
  eztrace_convert_gomp.c
)

target_link_libraries(
 eztrace-convert-omp
 gtg
 eztrace-convert-core
)

set_target_properties (eztrace-convert-omp PROPERTIES LINK_FLAGS "-DOPENMP_FOUND")

# Create : libPomp2
add_library(
  pomp2
  SHARED
  pomp-lib-dummy/pomp2_lib.c
  pomp-lib-dummy/pomp2_lib.h
  pomp-lib-dummy/pomp2_region_info.c
  pomp-lib-dummy/pomp2_region_info.h
  pomp-lib-dummy/pomp2_fwrapper.c
  pomp-lib-dummy/pomp2_fwrapper_base.c
  pomp-lib-dummy/pomp2_fwrapper_base.h
)

# Create : libeztrace-omp.so
add_library(
  eztrace-omp
  SHARED
  gomp.c
)

set_target_properties (eztrace-omp PROPERTIES LINK_FLAGS "-DOPENMP_FOUND")

target_link_libraries(
  eztrace-omp
  eztrace
  dl
  gomp
  litl
)

# Create : libeztrace-autostart-pthrad.so
add_library(
  eztrace-autostart-omp
  SHARED
  gomp.c
)

target_link_libraries(
  eztrace-autostart-omp
  eztrace
  dl
  litl
  gomp
)

set_target_properties(eztrace-autostart-omp PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART -DOPENMP_FOUND")
set_target_properties(eztrace-autostart-omp PROPERTIES LINK_FLAGS "-rdynamic -Wl,-no-undefined -Wl,-Bsymbolic")
configure_file (eztrace_cc.in ${CMAKE_CURRENT_BINARY_DIR}/bin/eztrace_cc @ONLY)
install(TARGETS pomp2 eztrace-convert-omp eztrace-omp eztrace-autostart-omp LIBRARY DESTINATION lib)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/bin/eztrace_cc DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/)

=== src/modules/papi/CMakeLists.txt ===
#include directories
include_directories(
  ../../core
  ../../pptrace
  ${CMAKE_BINARY_DIR}/include/
  ${LIBPAPI_INCLUDE_DIRS}
)
message(${LIBPAPI_LIBRARIES})
# Libraries diretory
link_directories(${CMAKE_BINARY_DIR}/lib/ ${CMAKE_BINARY_DIR}/extlib/lib/)

# Target : libeztrace-convert-papi.so
set(CMAKE_C_FLAGS ${C_FLAGS})

add_library(
  eztrace-convert-papi
  SHARED
  eztrace_convert_papi.c
)

target_link_libraries(
 eztrace-convert-papi
 gtg
 papi
)

# Target : libeztrace-papi.so
add_library(
  eztrace-papi
  SHARED
  papi.c
)

target_link_libraries(
  eztrace-papi
  eztrace
  dl
  papi
  ${INTERCEPT_LIB}
)

# Target :  libeztrace-autostart-papi.so
add_library(
  eztrace-autostart-papi
  SHARED
  papi.c
)

target_link_libraries(
 eztrace-autostart-papi
 eztrace
 pthread
 litl
  ${LIBPAPI_LIBRARIES}
)

set_target_properties (eztrace-autostart-papi PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART")
install(TARGETS eztrace-convert-papi eztrace-papi eztrace-autostart-papi LIBRARY DESTINATION lib)

=== src/modules/pthread/CMakeLists.txt ===
# Include directories
include_directories(
  ../../core
  ../../pptrace
  ${CMAKE_BINARY_DIR}/include/
)

# Libraries diretory
link_directories(${CMAKE_BINARY_DIR}/lib/ ${CMAKE_BINARY_DIR}/extlib/lib/)

# Create : libeztrace-convert-pthread.so
set(CMAKE_C_FLAGS ${C_FLAGS})

add_library(
  eztrace-convert-pthread
  SHARED
  eztrace_convert_pthread.c
)

target_link_libraries(
 eztrace-convert-pthread
 gtg
 pthread
)

# Create : libeztrace-pthread.so
add_library(
  eztrace-pthread
  SHARED
  pthread.c
)

target_link_libraries(
 eztrace-pthread
 dl
 pthread
)

# Create : libeztrace-autostart-pthrad.so
add_library(
  eztrace-autostart-pthread
  SHARED
  pthread.c
)

target_link_libraries(
 eztrace-pthread
 eztrace
 pthread
)

set(eztrace-autostart-pthread PROPERTIES COMPILE_FLAGS "-DEZTRACE_AUTOSTART")
install(TARGETS eztrace-convert-pthread eztrace-pthread eztrace-autostart-pthread LIBRARY DESTINATION lib)
